zstd(1)

NAME
zstd, unzstd, zstdcat - Compress or decompress .zst files

SYNOPSIS

zstd [OPTIONS] [-|INPUT-FILE] [-o <OUTPUT-FILE>]

unzstd is equivalent to zstd -d
zstdcat is equivalent to zstd -dc

DESCRIPTION

zstd is a fast lossless compression algorithm and data compression tool, with command line syntax similar to gzip (1) and xz (1) . It is based on the LZ77 family, with further FSE & huff0 entropy stages. zstd offers highly configurable compression speed, with fast modes at > 200 MB/s per core, and strong modes nearing lzma compression ratios. It also features a very fast decoder, with speeds > 500 MB/s per core. zstd command line syntax is generally similar to gzip, but features the following differences :
 - Source files are preserved by default.
   It's possible to remove them automatically by using --rm command.
 - When compressing a single file, zstd displays progress notifications and result summary by default.
   Use -q to turn them off

zstd compresses or decompresses each file according to the selected operation mode. If no files are given or file is -, zstd reads from standard input and writes the processed data to standard output. zstd will refuse (display an error and skip the file) to write compressed data to standard output if it is a terminal. Similarly, zstd will refuse to read compressed data from standard input if it is a terminal.

Unless --stdout is specified, files are written to a new file whose name is derived from the source file name:

•   When compressing, the suffix .zst is appended to the source filename to get the target filename.

•   When decompressing, the .zst suffix is removed from the filename to get the target filename.

  Concatenation with .zst files
It is possible to concatenate .zst files as is. zstd will decompress such files as if they were a single .zst file.

OPTIONS

  Integer suffixes and special values
In most places where an integer argument is expected, an optional suffix is supported to easily indicate large integers. There must be no space between the integer and the suffix.

KiB Multiply the integer by 1,024 (2^10). Ki, K, and KB are accepted as synonyms for KiB.

MiB Multiply the integer by 1,048,576 (2^20). Mi, M, and MB are accepted as synonyms for MiB.

  Operation mode
If multiple operation mode options are given, the last one takes effect.

-z, --compress
    Compress. This is the default operation mode when no operation mode option is specified and no other operation mode is implied from the command name (for example, unzstd implies --decompress).

-d, --decompress, --uncompress
    Decompress.

-t, --test
    Test the integrity of compressed files. This option is equivalent to --decompress --stdout except that the decompressed data is discarded instead of being written to standard output. No files are created or removed.

-b#
     benchmark file(s) using compression level #

--train FILEs
     use FILEs as training set to create a dictionary. The training set should contain a lot of small files (> 100).

  Operation modifiers

-#
     # compression level [1-19] (default:3)

--ultra
     unlocks high compression levels 20+ (maximum 22), using a lot more memory

-D file
     use `file` as Dictionary to compress or decompress FILE(s)

--no-dictID
     do not store dictionary ID within frame header (dictionary compression).
     The decoder will have to rely on implicit knowledge about which dictionary to use, it won't be able to check if it's correct.

-o file
     save result into `file` (only possible with a single INPUT-FILE)

-f, --force
     overwrite output without prompting

-c, --stdout
     force write to standard output, even if it is the console

--[no-]sparse
     enable / disable sparse FS support, to make files with many zeroes smaller on disk.
     Creating sparse files may save disk space and speed up the decompression by reducing the amount of disk I/O.
     default : enabled when output is into a file, and disabled when output is stdout.
     This setting overrides default and can force sparse mode over stdout.

--rm
     remove source file(s) after successful compression or decompression

-k, --keep
     keep source file(s) after successful compression or decompression.
     This is the default behavior.

-r
     operate recursively on directories

-h/-H, --help
     display help/long help and exit

-V, --version
     display Version number and exit

-v, --verbose
     verbose mode

-q, --quiet
     suppress warnings, interactivity and notifications.
     specify twice to suppress errors too.

-C, --[no-]check
     add integrity check computed from uncompressed data (default : enabled)

-t, --test
     Test the integrity of compressed files. This option is equivalent to --decompress --stdout > /dev/null.
     No files are created or removed.

--
     All arguments after -- are treated as files

DICTIONARY BUILDER

zstd offers dictionary compression, useful for very small files and messages. It's possible to train zstd with some samples, the result of which is saved into a file called `dictionary`. Then during compression and decompression, make reference to the same dictionary. It will improve compression ratio of small files. Typical gains range from ~10% (at 64KB) to x5 better (at <1KB).

--train FILEs
     use FILEs as training set to create a dictionary. The training set should contain a lot of small files (> 100), and weight typically 100x the target dictionary size (for example, 10 MB for a 100 KB dictionary)

-o file
     dictionary saved into `file` (default: dictionary)

--maxdict #
     limit dictionary to specified size (default : 112640)

--dictID #
     A dictionary ID is a locally unique ID that a decoder can use to verify it is using the right dictionary.
     By default, zstd will create a 4-bytes random number ID.
     It's possible to give a precise number instead.
     Short numbers have an advantage : an ID < 256 will only need 1 byte in the compressed frame header,
     and an ID < 65536 will only need 2 bytes. This compares favorably to 4 bytes default.
     However, it's up to the dictionary manager to not assign twice the same ID to 2 different dictionaries.

-s#
     dictionary selectivity level (default: 9)
     the smaller the value, the denser the dictionary, improving its efficiency but reducing its possible maximum size.

BENCHMARK

-b#
     benchmark file(s) using compression level #

-e#
     benchmark file(s) using multiple compression levels, from -b# to -e# (included).

-i#
     minimum evaluation time, in seconds (default : 3s), benchmark mode only

-B#
     cut file into independent blocks of size # (default: no block)

BUGS
Report bugs at:- https://github.com/facebook/zstd/issues

AUTHOR
Yann Collet